// Alex O.	02/16/2010
// based on Example 4-16 (pp. 122)
// in A.Arevalo et. all - "Programming the Cell Broadband Engine"

#include <stdio.h>
#include <stdlib.h>
#include <libspe2.h>
#include <string.h>

// macro for rounding input value to the next higher multiple of either 
// 16 or 128 (to fulfill MFC's DMA requirements)
#define spu_mfc_ceil128(value)  ((value + 127) & ~127)
#define spu_mfc_ceil16(value)   ((value +  15) &  ~15)
char str[256]  __attribute__ ((aligned(16)));

extern spe_program_handle_t spu;

int main(int argc, char *argv[])
{
    void *spe_argp, *spe_envp;
    spe_context_ptr_t spe_ctx;
    unsigned int entry = SPE_DEFAULT_ENTRY;

    // Prepare SPE parameters
    strcpy( str, "Fill in the form: Name: ..............................");
    printf("PPU: %s\n", str);
    spe_argp=(void*)str;
    spe_envp=(void*)strlen(str);
    spe_envp=(void*)spu_mfc_ceil16((unsigned int)spe_envp);//round up to 16B

    /* Create context */
    if ((spe_ctx = spe_context_create (0, NULL)) == NULL) {
         perror ("Failed creating context");
         exit (1);
    }

    /* Load program into context */
    if (spe_program_load (spe_ctx, &spu)) {
         perror ("Failed loading program");
         exit (1);
    }

    /* Create thread for each SPE context */
    if (spe_context_run(spe_ctx, &entry, 0, spe_argp, spe_envp, NULL) < 0) {
         perror ("Failed creating thread");
         exit (1);
    }

    // Wait for SPE thread to complete using spe_context_destroy function
    printf("PPU: %s\n", str); // did it fill in my form?

    spe_context_destroy(spe_ctx);

    return (0);
}
